# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulpcore.configuration import Configuration


class FilesystemExport(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'task': 'str',
        'publication': 'str',
        'repository_version': 'str',
        'start_repository_version': 'str'
    }

    attribute_map = {
        'task': 'task',
        'publication': 'publication',
        'repository_version': 'repository_version',
        'start_repository_version': 'start_repository_version'
    }

    def __init__(self, task=None, publication=None, repository_version=None, start_repository_version=None, local_vars_configuration=None):  # noqa: E501
        """FilesystemExport - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._task = None
        self._publication = None
        self._repository_version = None
        self._start_repository_version = None
        self.discriminator = None

        self.task = task
        if publication is not None:
            self.publication = publication
        if repository_version is not None:
            self.repository_version = repository_version
        if start_repository_version is not None:
            self.start_repository_version = start_repository_version

    @property
    def task(self):
        """Gets the task of this FilesystemExport.  # noqa: E501

        A URI of the task that ran the Export.  # noqa: E501

        :return: The task of this FilesystemExport.  # noqa: E501
        :rtype: str
        """
        return self._task

    @task.setter
    def task(self, task):
        """Sets the task of this FilesystemExport.

        A URI of the task that ran the Export.  # noqa: E501

        :param task: The task of this FilesystemExport.  # noqa: E501
        :type: str
        """

        self._task = task

    @property
    def publication(self):
        """Gets the publication of this FilesystemExport.  # noqa: E501

        A URI of the publication to be exported.  # noqa: E501

        :return: The publication of this FilesystemExport.  # noqa: E501
        :rtype: str
        """
        return self._publication

    @publication.setter
    def publication(self, publication):
        """Sets the publication of this FilesystemExport.

        A URI of the publication to be exported.  # noqa: E501

        :param publication: The publication of this FilesystemExport.  # noqa: E501
        :type: str
        """

        self._publication = publication

    @property
    def repository_version(self):
        """Gets the repository_version of this FilesystemExport.  # noqa: E501

        A URI of the repository version export.  # noqa: E501

        :return: The repository_version of this FilesystemExport.  # noqa: E501
        :rtype: str
        """
        return self._repository_version

    @repository_version.setter
    def repository_version(self, repository_version):
        """Sets the repository_version of this FilesystemExport.

        A URI of the repository version export.  # noqa: E501

        :param repository_version: The repository_version of this FilesystemExport.  # noqa: E501
        :type: str
        """

        self._repository_version = repository_version

    @property
    def start_repository_version(self):
        """Gets the start_repository_version of this FilesystemExport.  # noqa: E501

        The URI of the last-exported-repo-version.  # noqa: E501

        :return: The start_repository_version of this FilesystemExport.  # noqa: E501
        :rtype: str
        """
        return self._start_repository_version

    @start_repository_version.setter
    def start_repository_version(self, start_repository_version):
        """Sets the start_repository_version of this FilesystemExport.

        The URI of the last-exported-repo-version.  # noqa: E501

        :param start_repository_version: The start_repository_version of this FilesystemExport.  # noqa: E501
        :type: str
        """

        self._start_repository_version = start_repository_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FilesystemExport):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FilesystemExport):
            return True

        return self.to_dict() != other.to_dict()
